<!doctype html>
<html lang="en">

<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <meta name="description" content="">
  <meta http-equiv="Content-Security-Policy" content="default-src 'self'; script-src 'self' 'unsafe-eval' cdn.jsdelivr.net; style-src 'self' cdn.jsdelivr.net; font-src 'self' cdn.jsdelivr.net">
  <title>GitLab CVSS Calculator</title>
  <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.3/dist/css/bootstrap.min.css" rel="stylesheet" integrity="sha384-QWTKZyjpPEjISv5WaRU9OFeRpok6YctnYmDr5pNlyT2bRjXh0JMhjY6hW+ALEwIH" crossorigin="anonymous">
  <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.11.3/font/bootstrap-icons.min.css" integrity="sha384-XGjxtQfXaH2tnPFa9x+ruJTuLE3Aa6LhHSWRr1XeTyhezb4abCG4ccI5AkVDxqC+" crossorigin="anonymous">

  <link href="css/application.css" rel="stylesheet">
  <meta name="theme-color" content="#9b51e0">
  <script src="js/darktoggle.js"></script>
</head>

<body>

  <div class="container py-4 px-3 mx-auto">
    <header class="d-md-flex align-items-md-center pb-3 mb-5 border-bottom">
      <h1 class="h4 me-auto">

        <a href="/" class="d-flex align-items-center text-body text-decoration-none">
          <span>GitLab CVSS Calculator</span>
        </a>
      </h1>
      <div class="d-flex align-items-center gap-3">
        <div class="d-flex align-items-center dropdown color-modes">
          <button class="btn btn-link px-0 text-decoration-none dropdown-toggle d-flex align-items-center" id="bd-theme" type="button" aria-expanded="false" data-bs-toggle="dropdown" data-bs-display="static" aria-label="Toggle theme (dark)">
            <i class="bi-moon-stars-fill"></i>
            <span class="ms-2" id="bd-theme-text">Toggle theme</span>
          </button>
          <ul class="dropdown-menu dropdown-menu-end" aria-labelledby="bd-theme">
            <li>
              <button type="button" class="dropdown-item d-flex align-items-center" data-bs-theme-value="light" aria-pressed="false">
                <i class="bi-sun-fill"></i>
                Light
              </button>
            </li>
            <li>
              <button type="button" class="dropdown-item d-flex align-items-center active" data-bs-theme-value="dark" aria-pressed="true">
                <i class="bi-moon-stars-fill"></i>
                Dark
              </button>
            </li>
            <li>
              <button type="button" class="dropdown-item d-flex align-items-center" data-bs-theme-value="auto" aria-pressed="false">
                <i class="bi-circle-half"></i>
                Auto
              </button>
            </li>
          </ul>
        </div>
        <a href="https://gitlab.com/gitlab-com/gl-security/product-security/appsec/cvss-calculator" target="_blank" rel="noopener" class="text-decoration-none">View source on GitLab</a>
      </div>
    </header>

  </div>

  <main class="container">
    <div id="app">
      <p class="lead">
          This calculator is used to calculate bounties for vulnerabilities reported to GitLab's <a href="https://hackerone.com/gitlab">Bug Bounty Program on HackerOne</a> or via our <a href="https://about.gitlab.com/security/disclosure/">Responsible Disclosure Policy</a>.
          Answering the questions will calculate a severity score using the Common Vulnerability Scoring System (<a href="https://www.first.org/cvss/v3.1/specification-document">CVSS</a>)
          which is used to calculate a suggested bug bounty based on the impact.
      </p>

      <transition name="slide-fade" mode="out-in">
        <Question v-bind:question="current_question" :key="current_question.question"></Question>
      </transition>
      <SkipQuestions></SkipQuestions>

      <Definitions></Definitions>

      <div class="examples">
        <h3 id="other-bounty-examples">Other Bounty Examples</h3>
        <p>The suggested bounty amounts for issues that aren't exploitable but we would like to reward regardless are defined below:
          <ul>
            <li>Self-XSS: $100</li>
            <li>Dangling DNS records pointing to an attacker-controllable service or IP address: $712</li>
          </ul>
        </p>
        <h4 id="non-cvss-bounties">Non-CVSS Bounties</h4>
        <p>For leakage of GitLab customer data or other personal data, the suggested bounty amount would be as defined below. Note that each of these conditions presuppose that the data was leaked by GitLab and not the customer themselves:
          <ul>
            <li>Security-related documentation update: $100</li>
            <li>Information disclosure of unpatched GitLab security issues: $500, or bounty based on the amount of information leaked</li>
            <li>Leaked customer names: $500</li>
            <li>Leaked customer names, emails, financial data: $1,000</li>
            <li>GitLab team member personal data information leaked by GitLab (excluding email): $100 per affected team member, maximum $500. Please note that reports on these leaks through YouTube will not be awarded between 15th of August and 31th of October, as we are remediating a known issue. </li>
            <li>Leaked customer tokens, keys or credentials allowing access to non-GitLab environments: discretionary amount, we will attempt find an equivalence to if the customer system was a GitLab system and award based on that</li>
          </ul>
        </p>
        <p>For GitLab team member token disclosure, the suggested bounty amount would be as defined below. Note that to reach the "maintainer" level, the token needs to have maintainer access on gitlab-org/gitlab or an equivalent "production" project.
          <ul>
            <li>Leaked token for a non-prod system that doesn't match any criteria below: $500 (CI abuse possible)</li>
            <li>Leaked token for a Developer+ direct member of a group or project under the gitlab-com or gitlab-org namespaces, without sensitive data: $1000</li>
            <li>Leaked non-maintainer access token on gitlab.com: $7,500</li>
            <li>Leaked maintainer access token on gitlab.com: $15,000</li>
            <li>Leaked admin access token on gitlab.com: $35,000</li>
            <li>Leaked product project maintainer or admin access token on staging.gitlab.com: $15,000 (no customer data, admin and maintainer have similar impact)</li>
          </ul>
        </p>
        <p>Reports about intended behavior resulting in an update of our documentation will be rewarded with a $100 bounty, as long as this update is security related.</p>
      </div>
    </div>

    <div class="examples">
      <h3 id="clarifying-notes">Clarifying notes</h3>
      <p>
        <ul>
          <li>When evaluating Availability impacts for DoS that require sustained traffic, use the <a href="https://docs.gitlab.com/ee/administration/reference_architectures/1k_users.html">1k Reference Architecture</a>. The number of requests must be fewer than the "test request per seconds rates" and cause 10+ seconds of user-perceivable unavailability to rate the impact as <code>A:H</code>.</a></li>
          <li>The initial time to remediate is based on <a href="https://handbook.gitlab.com/handbook/security/product-security/vulnerability-management/#remediation-slas">the SLAs in our handbook</a>. A vulnerabilities due date is assigned by automation when imported into GitLab, and can change over time based on a number of factors.</li>
        </ul>
      </p>
    </div>
  </main>

  <script type="text/x-template" id="examples-template">
    <span></span>
  </script>

  <script type="text/x-template" id="answer-template">
    <div class="col-sm-6">
      <div class="card answer text-center h-100" v-on:click="answer.onSelect">
        <div class="card-body">
          <h5 class="card-title">{{ answer.answer }}</h5>
          <h6 class="card-subtitle mb-2 text-muted" v-if="answer.extra">{{ answer.extra }}</h6>
          <Examples v-if="answer.examples" v-bind:examples="answer.examples"></Examples>
        </div>
      </div>
    </div>
  </script>

  <script type="text/x-template" id="question-template">
    <div class="question">
      <h3 class="border-bottom text-muted fw-lighter">{{ question.title }}</h3>
      <h2>{{ question.question }}</h2>
      <p v-if="question.extra">{{ question.extra }}</p>
      <div class="answers">
        <div class="row">
          <QuestionAnswer
            v-bind:key="answer.answer"
            v-for="answer in question.answers"
            v-bind:answer="answer"
          ></QuestionAnswer>
        </div>
      </div>
    </div>
  </script>

  <script type="text/x-template" id="skip-questions-template">
    <div class="skip-questions">
      <a href="#" v-on:click="showForm" v-show="!formShown">Skip questions, I already have a CVSS vector.</a>
      <form v-show="formShown">
        <div class="input-group input-group-lg">
          <input type="text" class="form-control" v-model="cvssVector" placeholder="CVSS vector... e.g. CVSS:3.1/AV:N/AC:L/PR:H/UI:R/S:C/C:H/I:H/A:H" aria-label="CVSS Vector" aria-describedby="button-submit-cvss-vector" required>
          <button class="btn btn-outline-primary" type="button" id="button-submit-cvss-vector" :disabled="!validCvssVector" v-on:click="showScore">Submit</button>
        </div>
      </form>
    </div>
  </script>

  <script type="text/x-template" id="score-card-template">
    <div class="col-sm">
      <div class="card score-card text-center text-white mb-3" ref="card" data-bs-toggle="popover"
        :class="{ 'bg-danger': severityHigh, 'bg-warning': severityMedium, 'bg-success': severityLow }">
        <div class="card-header">{{ metric }}</div>
        <div class="card-body">
          <h5 class="card-title">{{ humanFriendlyScore }}</h5>
        </div>
      </div>
    </div>
  </script>

  <script type="text/x-template" id="score-modal-template">
    <div class="modal modal-fade" tabindex="-1" id="score-modal" aria-hidden="true">
      <div class="modal-dialog modal-xl">
        <div class="modal-content">
          <div class="modal-header">
            <h5 class="modal-title">
              <span v-if="oldCVSSVersion"><a title="CVSS3.0 is deprecated at GitLab">⚠️</a>&nbsp;&nbsp;</span>
              {{cvssVector}} <span class="badge rounded-pill"
              :class="{ 'bg-danger': severityCritical || severityHigh, 'bg-warning': severityMedium, 'bg-success': severityLow }">{{ cvssScore }} ({{ severity }})</span></h5>
            <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
          </div>
          <div class="modal-body">
            <div class="row">
              <ScoreCard
                v-for="(score, metric) in cvssMetrics"
                v-bind:metric="metric"
                v-bind:score="score"
                v-bind:key="metric"></ScoreCard>
            </div>

            <div class="bounty text-center">
              <h2 class="display-6">💰 Suggested Bounty 💰</h2>
              <h3 class="display-5">{{ suggestedBounty }}</h3>
            </div>

            <div class="due-date text-center">
              <p>
                Initial <a href="https://handbook.gitlab.com/handbook/security/product-security/vulnerability-management/#remediation-slas">time to remediate</a>:
                <span v-if="severityCritical || severityHigh">30</span>
                <span v-if="severityMedium">90</span>
                <span v-if="severityLow">180</span>
                days
              </p>
            </div>

            <div class="bounty-range text-center" v-if="bountyRange == 'old'">
              <p>⚠️&nbsp;&nbsp; Bounty Range: Pre Nov 22, 2021</p>
            </div>

          </div>
          <div class="modal-footer">
            <p class="text-right text-muted" v-if="oldCVSSVersion">⚠️&nbsp;&nbsp;CVSS3.0 is deprecated at GitLab. Use CVSS3.1.</p>
            <button type="button" class="btn btn-primary" v-on:click="copyMarkdownLinkToClipboard" ref="btnCopyMarkdownLink">Copy Markdown link</button>
            <button type="button" class="btn btn-primary" v-on:click="copyURLToClipboard" ref="btnCopyUrl">Copy URL</button>
            <button type="button" class="btn btn-primary" v-on:click="copyVectorToClipboard" ref="btnCopyVector">Copy vector</button>
            <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Close</button>
          </div>
        </div>
      </div>
    </div>
  </script>

  <script type="text/x-template" id="definitions-template">
    <div class="definitions">
      <a href="#" v-on:click="toggleDefinitions" v-show="!definitionsShown">Show help & definitions.</a>
      <a href="#" v-on:click="toggleDefinitions" v-show="definitionsShown">Hide help & definitions.</a>
      <div v-show="definitionsShown">
        <h3 id="background">Background</h3>
        <p>
          Accuracy and consistency of these scores is important. At any time when deciding on a score do not hesitate to ask for advice in the Bug Bounty Council issue or by reaching out to team members by any way you see fit. All CVSS & bounty amounts are <a href="https://about.gitlab.com/handbook/engineering/security/security-engineering-and-research/application-security/runbooks/hackerone-process.html#awards">peer reviewed</a> as described in <a href="https://about.gitlab.com/handbook/engineering/security/security-engineering-and-research/application-security/runbooks/hackerone-process.html">our HackerOne Process runbook</a>.
        </p>
        <p>
          CVSS is owned by FIRST and used by permission. This calculator is based on the <a href="https://www.first.org/cvss/user-guide">FIRST CVSS user guide</a>, especially the <a href="https://www.first.org/cvss/user-guide#Scoring-Rubrics">Scoring Rubrics section</a>. Remember, in particular, to "constrain impacts to a reasonable final impact which they are confident an attacker is able to achieve".
        </p>
        <p>Contribute to, fork, or view the history of this calculator at <a href="https://gitlab.com/-/ide/project/gitlab-com/gl-security/product-security/appsec/cvss-calculator">https://gitlab.com/-/ide/project/gitlab-com/gl-security/product-security/appsec/cvss-calculator</a>.</p>
       
        <h3 id="reasonableconfig">Reasonable Configuration Assumptions When Calculating Score</h3>

        <h4 id="smconfig">Self-Managed (Official CVE)</h4>
        <p>
          <ul>
            <li>User Registration: Admin approval is required for new user accounts</li>
            <li>SAML Functionality Utilized: Instance or group SAML is not used</li>
          </ul>
        </p>

        <h4 id="saasconfig">GitLab.com SaaS</h4>
        <p>
          <ul>
            <li>Internet Reachability: Accessible from the Internet</li>
            <li>User Registration: Allows public registration for end users</li>
            <li>SAML Functionality Utilized: Only group SAML is used</li>
          </ul>
        </p>

        <h4 id="dedicatedconfig">GitLab Dedicated</h4>
        <p>
          <ul>
            <li>Internet Reachability: Not accessible from the Internet</li>
            <li>User Registration: Public registration for end users is not enabled</li>
            <li>SAML Functionality Utilized: Either instance or group SAML is used</li>
          </ul>
        </p>

        <h3 id="metrics">Metrics</h3>
        <table class="table table-striped table-sm">
          <thead>
            <tr>
              <td>Metric</td>
              <td>Definition</td>
              <td>Examples</td>
            </tr>
          </thead>
          <tbody>
            <tr class="example" v-for="definition in definitions">
              <td>
                <code>{{ definition.metric_value }}</code>
              </td>
              <td>
                {{ definition.extra }}
              </td>
              <td>
                <ul>
                  <li class="example" v-for="example in definition.examples">{{ example }}</li>
                </ul>
              </td>
            </tr>
          </tbody>
        </table>
      </div>
    </div>
  </script>


  <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-YvpcrYf0tY3lHB60NNkmXc5s9fDVZLESaAA55NDzOxhy9GkcIdslK1eN7N6jIeHz" crossorigin="anonymous"></script>
  <script src="https://cdn.jsdelivr.net/npm/vue@2.6.12/dist/vue.js"></script>
  <script src="js/cvsscalc30.js"></script>
  <script src="js/cvsscalc31.js"></script>
  <script src="js/application.js"></script>
</body>

</html>
